diff --git a/hw/fdc.c b/hw/fdc.c
index 9fdbc75..1f3bbd2 100644
--- a/hw/fdc.c
+++ b/hw/fdc.c
@@ -36,6 +36,7 @@
 #include "qdev-addr.h"
 #include "blockdev.h"
 #include "sysemu.h"
+#include "block_int.h"
 
 /********************************************************/
 /* debug Floppy devices */
@@ -67,6 +68,8 @@ typedef enum FDiskFlags {
     FDISK_DBL_SIDES  = 0x01,
 } FDiskFlags;
 
+typedef struct FDCtrl FDCtrl;
+
 typedef struct FDrive {
     BlockDriverState *bs;
     /* Drive status */
@@ -82,6 +85,8 @@ typedef struct FDrive {
     uint8_t max_track;        /* Nb of tracks           */
     uint16_t bps;             /* Bytes per sector       */
     uint8_t ro;               /* Is read-only           */
+    uint8_t media_changed;    /* Is media changed       */
+    FDCtrl *fdctrl;
 } FDrive;
 
 static void fd_init(FDrive *drv)
@@ -201,8 +206,6 @@ static void fd_revalidate(FDrive *drv)
 /********************************************************/
 /* Intel 82078 floppy disk controller emulation          */
 
-typedef struct FDCtrl FDCtrl;
-
 static void fdctrl_reset(FDCtrl *fdctrl, int do_irq);
 static void fdctrl_reset_fifo(FDCtrl *fdctrl);
 static int fdctrl_transfer_handler (void *opaque, int nchan,
@@ -414,6 +417,7 @@ struct FDCtrl {
     uint8_t num_floppies;
     FDrive drives[MAX_FD];
     int reset_sensei;
+    uint8_t default_migration_media_changed;
 };
 
 typedef struct FDCtrlSysBus {
@@ -533,16 +537,82 @@ static CPUWriteMemoryFunc * const fdctrl_mem_write_strict[3] = {
     NULL,
 };
 
+static int fdrive_pre_load(void *opaque)
+{
+    FDrive *drive = opaque;
+
+    if (drive->bs != NULL) {
+        drive->media_changed = drive->fdctrl->default_migration_media_changed;
+    }
+
+    return 0;
+}
+
+static void fdrive_pre_save(void *opaque)
+{
+    FDrive *drive = opaque;
+
+    if (drive->bs != NULL) {
+        drive->media_changed = drive->bs->media_changed;
+    }
+}
+
+static int fdrive_post_load(void *opaque, int version_id)
+{
+    FDrive *drive = opaque;
+
+    if (drive->bs == NULL) {
+        return 1;
+    } else {
+        drive->bs->media_changed = drive->media_changed;
+        return 0;
+    }
+}
+
+static bool fdrive_media_changed_needed(void *opaque)
+{
+    FDrive *drive = opaque;
+
+    /* Only save media_changed when it was not equal to default to avoid saving
+     * subsections as much as possible.
+     */
+    return (drive->bs != NULL &&
+            drive->bs->media_changed !=
+            drive->fdctrl->default_migration_media_changed);
+}
+
+static const VMStateDescription vmstate_fdrive_media_changed = {
+    .name = "fdrive/media_changed",
+    .version_id = 1,
+    .minimum_version_id = 1,
+    .minimum_version_id_old = 1,
+    .fields      = (VMStateField[]) {
+        VMSTATE_UINT8(media_changed, FDrive),
+        VMSTATE_END_OF_LIST()
+    }
+};
+
 static const VMStateDescription vmstate_fdrive = {
     .name = "fdrive",
     .version_id = 1,
     .minimum_version_id = 1,
     .minimum_version_id_old = 1,
-    .fields      = (VMStateField []) {
+    .pre_load = fdrive_pre_load,
+    .pre_save = fdrive_pre_save,
+    .post_load = fdrive_post_load,
+    .fields      = (VMStateField[]) {
         VMSTATE_UINT8(head, FDrive),
         VMSTATE_UINT8(track, FDrive),
         VMSTATE_UINT8(sect, FDrive),
         VMSTATE_END_OF_LIST()
+    },
+    .subsections = (VMStateSubsection[]) {
+        {
+            .vmsd = &vmstate_fdrive_media_changed,
+            .needed = &fdrive_media_changed_needed,
+        } , {
+            /* empty */
+        }
     }
 };
 
@@ -1766,6 +1836,7 @@ static int fdctrl_connect_drives(FDCtrl *fdctrl)
         fd_revalidate(drive);
         if (drive->bs) {
             bdrv_set_removable(drive->bs, 1);
+        drive->fdctrl = fdctrl;
         }
     }
     return 0;
@@ -1934,6 +2005,8 @@ static ISADeviceInfo isa_fdc_info = {
         DEFINE_PROP_DRIVE("driveB", FDCtrlISABus, state.drives[1].bs),
         DEFINE_PROP_INT32("bootindexA", FDCtrlISABus, bootindexA, -1),
         DEFINE_PROP_INT32("bootindexB", FDCtrlISABus, bootindexB, -1),
+        DEFINE_PROP_UINT8("default_migration_media_changed", FDCtrlISABus,
+                          state.default_migration_media_changed, 0),
         DEFINE_PROP_END_OF_LIST(),
     },
 };
@@ -1957,6 +2030,8 @@ static SysBusDeviceInfo sysbus_fdc_info = {
     .qdev.props = (Property[]) {
         DEFINE_PROP_DRIVE("driveA", FDCtrlSysBus, state.drives[0].bs),
         DEFINE_PROP_DRIVE("driveB", FDCtrlSysBus, state.drives[1].bs),
+        DEFINE_PROP_UINT8("default_migration_media_changed", FDCtrlSysBus,
+                          state.default_migration_media_changed, 0),
         DEFINE_PROP_END_OF_LIST(),
     },
 };
@@ -1969,6 +2044,8 @@ static SysBusDeviceInfo sun4m_fdc_info = {
     .qdev.reset = fdctrl_external_reset_sysbus,
     .qdev.props = (Property[]) {
         DEFINE_PROP_DRIVE("drive", FDCtrlSysBus, state.drives[0].bs),
+        DEFINE_PROP_UINT8("default_migration_media_changed", FDCtrlSysBus,
+                          state.default_migration_media_changed, 0),
         DEFINE_PROP_END_OF_LIST(),
     },
 };
diff --git a/hw/pc_piix.c b/hw/pc_piix.c
index b3ede89..b80551a 100644
--- a/hw/pc_piix.c
+++ b/hw/pc_piix.c
@@ -258,6 +258,18 @@ static QEMUMachine pc_machine_v0_13 = {
             .driver   = "PCI",
             .property = "command_serr_enable",
             .value    = "off",
+        }, {
+            .driver   = "isa-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "sysbus-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "SUNW,fdtwo",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
         },
         { /* end of list */ }
     },
@@ -289,6 +301,18 @@ static QEMUMachine pc_machine_v0_12 = {
             .driver   = "PCI",
             .property = "command_serr_enable",
             .value    = "off",
+        }, {
+            .driver   = "isa-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "sysbus-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "SUNW,fdtwo",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
         },
         { /* end of list */ }
     }
@@ -328,6 +352,18 @@ static QEMUMachine pc_machine_v0_11 = {
             .driver   = "PCI",
             .property = "command_serr_enable",
             .value    = "off",
+        }, {
+            .driver   = "isa-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "sysbus-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "SUNW,fdtwo",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
         },
         { /* end of list */ }
     }
@@ -379,6 +415,18 @@ static QEMUMachine pc_machine_v0_10 = {
             .driver   = "PCI",
             .property = "command_serr_enable",
             .value    = "off",
+        }, {
+            .driver   = "isa-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "sysbus-fdc",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
+        }, {
+            .driver   = "SUNW,fdtwo",
+            .property = "default_migration_media_changed",
+            .value = stringify(1),
         },
         { /* end of list */ }
     },